=== debian/changelog ===
rustc (1.34.2+dfsg1-1) unstable; urgency=medium

  * Don't use system compiler-rt, there are issues with that for now.
  * Downgrade back to LLVM 7, easier for the buster release.

 -- Ximin Luo <infinity0@debian.org>  Wed, 29 May 2019 21:52:37 -0700

rustc (1.34.2+dfsg1-1~exp2) experimental; urgency=medium

  * Fix doc build, add version 1 compat mode hack for mdBook 2.
  * Use system compiler-rt from libclang-common-*-dev.

 -- Ximin Luo <infinity0@debian.org>  Fri, 24 May 2019 00:39:59 -0700

rustc (1.34.2+dfsg1-1~exp1) experimental; urgency=medium

  * Ensure Cargo.toml is in rust-src.
  * New upstream release.
  * Update to LLVM 8.

 -- Ximin Luo <infinity0@debian.org>  Sun, 19 May 2019 02:40:02 -0700

rustc (1.33.0+dfsg1-2) unstable; urgency=medium

  * Add Fedora patches.
  * Bump i386 allowed test failures to 12.

 -- Ximin Luo <infinity0@debian.org>  Sat, 18 May 2019 12:18:25 -0700

rustc (1.33.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.
  * Fix build on mips, flags needed whitespace massaging.
  * Drop obsolete patches.

 -- Ximin Luo <infinity0@debian.org>  Fri, 17 May 2019 21:04:20 -0700
