=== debian/watch ===
version=4
# if you need to download other versions replace the URL below with this one:
# https://static.rust-lang.org/dist/index.html
# it's a bit slower to download, that's why we use the other one normally

opts="\
pgpsigurlmangle=s/$/.asc/,\
uversionmangle=s/(\d)[_.+-]?((beta|alpha)\.?\d*)$/$1~$2/,\
dversionmangle=s/\+dfsg\d*$//,\
downloadurlmangle=s/\.[gx]z/.xz/,\
filenamemangle=s/.*\/(.*)\.[gx]z(\..*)?/$1.xz$2/,\
repack,\
repacksuffix=+dfsg1,\
compression=xz,\
" \
 https://forge.rust-lang.org/other-installation-methods.html \
 (?:.*/)rustc?-(\d[\d.]*(?:-[\w.]+)?)-src\.tar\.[gx]z
