=== debian/changelog ===
rustc (1.35.0+dfsg1-1+rpi1) bullseye-staging; urgency=medium

  [changes brought forward from 1.15.1+dfsg1-1~exp3+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Wed, 15 Mar 2017 10:16:18 +0000]
  * Build for armv6.
  [changes introduced in 1.18.0+dfsg1-4+rpi1 by Peter Michael Green]
  * Disable testsuite.

 -- Raspbian forward porter <root@raspbian.org>  Thu, 12 Sep 2019 22:49:59 +0000

rustc (1.35.0+dfsg1-1) unstable; urgency=medium

  * Add entry in 1.34.2+dfsg1-1 to note that it uses LLVM 7.
  * Add entry in 1.35.0+dfsg1-1~exp2 to note that it uses LLVM 8.
  * Fix ICE on sparc64 by including upstream PR #61881.

 -- Ximin Luo <infinity0@debian.org>  Sat, 13 Jul 2019 10:30:35 -0700

rustc (1.35.0+dfsg1-1~exp1) experimental; urgency=medium

  * Don't use system compiler-rt, it's not ready yet.
  * Update to LLVM 8.
  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Sun, 09 Jun 2019 23:20:52 -0700
