=== debian/control ===
--- 
+++ 
@@ -10,11 +10,11 @@
                dpkg-dev (>= 1.17.14),
                python:native,
                cargo:native (>= 0.31.0)      <!pkg.rustc.dlstage0>,
-               rustc:native (>= 1.33.0+dfsg) <!pkg.rustc.dlstage0>,
-               rustc:native (<= 1.34.2++)    <!pkg.rustc.dlstage0>,
-               llvm-7-dev:native,
-               llvm-7-tools:native,
-               libllvm7 (>= 1:7.0.1-3),
+               rustc:native (>= 1.34.0+dfsg) <!pkg.rustc.dlstage0>,
+               rustc:native (<= 1.35.0++)    <!pkg.rustc.dlstage0>,
+               llvm-8-dev:native,
+               llvm-8-tools:native,
+               libllvm8,
                autotools-dev,
                cmake (>= 3.0) | cmake3,
 # needed by some vendor crates
@@ -49,7 +49,7 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-dev (= ${binary:Version}),
  gcc, libc-dev, binutils (>= 2.26)
-Recommends: cargo (>= 0.35.0~~), cargo (<< 0.36.0~~), rust-gdb | rust-lldb
+Recommends: cargo (>= 0.36.0~~), cargo (<< 0.37.0~~), rust-gdb | rust-lldb
 Suggests: rust-doc, rust-src
 Replaces: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
 Breaks: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
@@ -66,7 +66,7 @@
  generic programming and meta-programming, in both static and dynamic
  styles.
 
-Package: libstd-rust-1.34
+Package: libstd-rust-1.35
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -91,7 +91,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-1.34 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-1.35 (= ${binary:Version})
 Description: Rust standard libraries - development files
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -132,7 +132,7 @@
 Package: rust-lldb
 Architecture: all
 # When updating, also update rust-lldb.links
-Depends: lldb-7, ${misc:Depends}, python-lldb-7
+Depends: lldb-8, ${misc:Depends}, python-lldb-8
 Replaces: rustc (<< 1.1.0+dfsg1-1)
 Description: Rust debugger (lldb)
  Rust is a curly-brace, block-structured expression language.  It
