=== debian/rules ===
--- 
+++ 
@@ -32,8 +32,8 @@
 DEB_DESTDIR := $(CURDIR)/debian/tmp
 
 # Use system LLVM (comment out to use vendored LLVM)
-LLVM_VERSION = 7
-OLD_LLVM_VERSION = 6.0
+LLVM_VERSION = 8
+OLD_LLVM_VERSION = 7
 # Make it easier to test against a custom LLVM
 ifneq (,$(LLVM_DESTDIR))
 LLVM_LIBRARY_PATH := $(LLVM_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(LLVM_DESTDIR)/usr/lib
